class UT2048 extends UWindowDialogClientWindow config(UT2048);

//a simple clone of the 2048 game
//type the console command tzfe to play
//TODO: game over check doesn't work? - 2016 maybe fixed?
//TODO: problem with loading game when window was closed?

#exec OBJ LOAD FILE="..\Textures\Color.utx" PACKAGE=Color

var config int Tile[16];
var config int Score;
var config int TopScore;
var bool bPress,bGameOver;//are we pressing a key,is game over?
var R6WindowButton bWinner;
var R6WindowTextLabel tSq[16];

//sets new game button
//sets up the 16 text areas
//loads a previous game
function Created()
{
	local int i;
	local bool bGameInP;
	local int betw;//amount between squares
	local int size;//size of a square side
	local int cX,cY;
	local int sX,sY;//starting xy coords - can adjust to shift entire structure
	//player instructions
	GetPlayerOwner().ClientMessage("To play '2048', use arrow keys to move the numbers.");
	GetPlayerOwner().ClientMessage("If two squares with the same number touch, they will merge and get bigger.");
	GetPlayerOwner().ClientMessage("Game '2048' originally by Gabriele Cirulli, adapted for Rvs by Twi.");
	super.Created();
	betw = 1;
	size = 60;
	sX = WinLeft + 1;
	sY = WinTop + 16;
	LoadConfig();
	SetAcceptsHotKeys(true);//can get hotkey function
	bWinner = R6WindowButton(CreateControl(class'R6WindowButton',WinLeft+5,WinTop,WinWidth,15,self));
	bWinner.SetText("New Game");
	i = 0;
	bGameInP = false;
	while ( i < 16 )//detect if a game is in progress
	{
		if ( Tile[i] != 0 )
		bGameInP = true;
		i++;
	}
	if ( !bGameInP )
	NewGame();
	i = 0;
	while ( i < 16 )//load all display text labels
	{
		GetCoords(i,size,betw,cX,cY);
		tSq[i] = R6WindowTextLabel(CreateWindow(class'R6WindowTextLabel',cX+sX,cY+sY,size,size,self));
		tSq[i].m_bDrawBorders = false;
		tSq[i].Align = TA_Center;
		tSq[i].m_Font = Root.Fonts[F_SmallTitle];
		tSq[i].m_BGTexture = none;
		i++;
	}
	UTApp(ParentWindow).m_szWindowTitle = "Score: " $ string(Score) $ " Best: " $ string(TopScore);
	UpdateTiles();
}

//moves all tiles a selected amount
//if tiles are moved by this function, updates all locations and display
function Move(int iterf,int rowcol)
{
	local int sq,moves,rows,tempsq,tempmov,istart,i;
	local bool bMoved;//did the board move
	local bool bFound;//was the square found in our list of doubled squares
	local array<int> iDoubled;//any square that is doubled and cannot be doubled again this turn
	if ( bGameOver )
	return;
	if ( iterf < 0 )//get the starting square
	istart = iterf * -1;
	else
	istart = iterf * 2;
	bMoved = false;
	rows = 0;
	while ( rows < 4 )//4 rows or columns to work with
	{
		moves = 0;
		sq = istart;
		while ( moves < 3 )
		{
			moves++;
			tempsq = sq;
			tempmov = moves;//how many squares ahead to check
			if ( Tile[sq] != 0 )//only try to move non-zero tiles
			{
				while ( ( tempmov > 0 ) && ( Tile[tempsq + iterf] == 0 ) )//still have squares ahead to check, and square ahead is clear
				{
					Tile[tempsq + iterf] = Tile[tempsq];//move the number
					Tile[tempsq] = 0;//clear previous square
					bMoved = true;//tell the game to fill a random square
					tempsq = tempsq + iterf;
					tempmov--;
				}
				if ( ( tempmov > 0 ) && ( Tile[tempsq + iterf] == Tile[tempsq] ) )//still have squares to check, and next square is the same
				{
					i = 0;
					bFound = false;
					while ( i < iDoubled.length )//check the list of all squares that have doubled this turn
					{
						if ( iDoubled[i] == tempsq + iterf )//the square we are checking has already been doubled this move
						bFound = true;
						i++;
					}
					if ( !bFound )
					{
						Tile[tempsq + iterf] = Tile[tempsq] * 2;//double the number
						Score = Score + ( Tile[tempsq] * 2 );//add the newly doubled square to score
						if ( Score > TopScore )//update high score
						TopScore = Score;
						UTApp(ParentWindow).m_szWindowTitle = "Score: " $ string(Score) $ " Best: " $ string(TopScore);//update score display
						Tile[tempsq] = 0;//clear previous square
						bMoved = true;//tell the game to fill a random square
						iDoubled[iDoubled.length] = tempsq + iterf;//add this to the list of squares we can no longer double this move
					}
				}
			}
			sq = sq - iterf;
		}
		istart = istart + rowcol;//move to next row or column
		rows++;
	}
	if ( bMoved )//need to fill a random square, need to update square display
	{
		FillRandomTile();
		UpdateTiles();
	}
	else if ( !bGameOver)//need to set game over! - 2016 fix for game over bug in FillRandomTile()?
	{
		bGameOver = true;
		bWinner.SetText("You Lost - New Game?");
	}
}

//finds a random tile, and sets it to a number
//sets gameover if can't do it - GAMEOVER DOESNT WORK?
//possibly because this function doesn't get called unless bMoved is true up above, and if it's a game over, bMoved will never be true
function FillRandomTile()
{
	local array<int> Free;
	local int i,j;
	i = 0;
	while ( i < 16 )
	{
		if ( Tile[i] == 0 )//if it's a free tile
		Free[Free.length] = i;//store the tile
		i++;
	}
	if ( rand(4) == 0 )//occasionally fill with a 4 instead of a 2
	j = 4;
	else
	j = 2;
	if ( Free.length == 0 )//no free tile to fill
	{
		bGameOver = true;
		bWinner.SetText("You Lost - New Game?");
	}
	else
	Tile[Free[rand(Free.length)]] = j;//set a randomly chosen tile from the free list to either 2 or 4
}

//sets all tiles to blank, and loads two tiles
//resets score, saves the game
function NewGame()
{
	local int i,j;
	i = 0;
	while ( i < 16 )
	{
		Tile[i] = 0;
		i++;
	}
	Score = 0;
	UTApp(ParentWindow).m_szWindowTitle = "Score: " $ string(Score) $ " Best: " $ string(TopScore);
	FillRandomTile();
	FillRandomTile();
	bGameOver = false;
	SaveConfig();//save that we started a new game
}

//sets all tiles to show their updated numbers
function UpdateTiles()
{
	local int i;
	i = 0;
	while ( i < 16 )
	{
		if ( Tile[i] == 0 )
		tSq[i].Text = " ";
		else
		tSq[i].Text = string(Tile[i]);
		i++;
	}
}

//gets player input
function bool HotKeyDown(int Key,float X,float Y)
{
	if ( !bPress )
	{
		switch ( Key )
		{
			case Root.Console.EInputKey.IK_Left://move -1 (left), difference between each row is 4
			Move(-1,4);
			break;
			case Root.Console.EInputKey.IK_Right://move 1 (right), difference between each row is 4
			Move(1,4);
			break;
			case Root.Console.EInputKey.IK_Up://move -4 (up), difference between each column is 1
			Move(-4,1);
			break;
			case Root.Console.EInputKey.IK_Down://move 4 (down), difference between each column is 1
			Move(4,1);
			break;
		}
		SaveConfig();//save after every move
		bPress = true;
	}
	return false;
}

//we have let go of a button, we can now press another button
function bool HotKeyUp(int Key,float X,float Y)
{
	bPress = false;
	return false;
}

//if we click new game
function Notify (UWindowDialogControl C,byte E)
{
	if ( Root.Console.IsInState('Game') )//can't click when playing
	return;
	super.Notify(C,E);
	if ( E == DE_click )
	{
		switch (C)
		{
			case bWinner:
			NewGame();
			UpdateTiles();
			bWinner.SetText("New Game");
			break;
		}
	}
}

//draws the squares
function Paint(Canvas C,float X,float Y)
{
	local int sX,sY;//starting xy coords - can adjust to shift entire structure
	local int cX,cY;//current xy coords
	local int betw;//amount between squares
	local int size;//size of a square side
	local int i;
	local int cR,cM;//amount of red, amount of blue to minus
	//draw boxes before super paint?
	sX = WinLeft + 1;
	sY = WinTop + 16;
	betw = 1;
	size = 60;
	C.Style = 5;//alpha
	cR = 0;
	cM = 0;
	i = 0;
	while ( i < 16 )
	{
		GetCoords(i,size,betw,cX,cY);
		GetColor(Tile[i],cR,cM);
		C.SetDrawColor(cR,255-cR,255-cM,160);//alpha amount?
		DrawStretchedTexture(C,cX+sX,cY+sY,size,size,Texture'Color.White');
		i++;
	}
	super.Paint(C,X,Y);
}

//takes a tile's value
//sets red and 255-blue values based on the tile's value
function GetColor(int num,out int cr,out int cm)
{
	local int i;
	i = 0;
	while ( num > 2 )//find out how many levels we are
	{
		num = num / 2;
		i++;
	}
	cr = Min(26 * i,255);
	cm = Min(40 * i,255);
}

//takes a tile number and finds where it is
//takes into account size of tiles and distance between tiles
function GetCoords(int iT,int size,int betw,out int x,out int y)
{
	local int rownum;
	rownum = 0;
	while ( iT > 3 )
	{
		rownum++;
		iT = iT - 4;
	}
	x = iT * ( size + betw);
	y = rownum * ( size + betw);
}