class UT4App extends UWindowDialogClientWindow;

//simple tic tac toe game window

var R6WindowButton Spot[9];
var R6WindowButton bComp,bReset;
var R6WindowTextLabel tWinner;
var int Played[9];//0 is no, 1 is human, 2 is comp
var bool bOver;//game over

function Notify (UWindowDialogControl C,byte E)
{
	local int i;
	if ( Root.Console.IsInState('Game') )//can't click when playing
	return;
	super.Notify(C,E);
	if ( E == DE_click )
	{
		if ( bOver && ( C != bReset ) )
		return;
		switch (C)
		{
			case Spot[0]:
			if ( Played[0] == 0 )
			{
				Spot[0].SetText("X");
				Played[0] = 1;
				if ( IsWinner() == 1 )
					Winner(1);
				else
				ComputerGo();
			}
			break;
			case Spot[1]:
			if ( Played[1] == 0 )
			{
				Spot[1].SetText("X");
				Played[1] = 1;
				if ( IsWinner() == 1 )
					Winner(1);
				else
				ComputerGo();
			}
			break;
			case Spot[2]:
			if ( Played[2] == 0 )
			{
				Spot[2].SetText("X");
				Played[2] = 1;
				if ( IsWinner() == 1 )
					Winner(1);
				else
				ComputerGo();
			}
			break;
			case Spot[3]:
			if ( Played[3] == 0 )
			{
				Spot[3].SetText("X");
				Played[3] = 1;
				if ( IsWinner() == 1 )
					Winner(1);
				else
				ComputerGo();
			}
			break;
			case Spot[4]:
			if ( Played[4] == 0 )
			{
				Spot[4].SetText("X");
				Played[4] = 1;
				if ( IsWinner() == 1 )
					Winner(1);
				else
				ComputerGo();
			}
			break;
			case Spot[5]:
			if ( Played[5] == 0 )
			{
				Spot[5].SetText("X");
				Played[5] = 1;
				if ( IsWinner() == 1 )
					Winner(1);
				else
				ComputerGo();
			}
			break;
			case Spot[6]:
			if ( Played[6] == 0 )
			{
				Spot[6].SetText("X");
				Played[6] = 1;
				if ( IsWinner() == 1 )
					Winner(1);
				else
				ComputerGo();
			}
			break;
			case Spot[7]:
			if ( Played[7] == 0 )
			{
				Spot[7].SetText("X");
				Played[7] = 1;
				if ( IsWinner() == 1 )
					Winner(1);
				else
				ComputerGo();
			}
			break;
			case Spot[8]:
			if ( Played[8] == 0 )
			{
				Spot[8].SetText("X");
				Played[8] = 1;
				if ( IsWinner() == 1 )
					Winner(1);
				else
				ComputerGo();
			}
			break;
			case bComp:
			ComputerGo();
			break;
			case bReset:
			i = 0;
			while ( i < 9 )
			{
				Spot[i].SetText(" ");//reset each square visual
				Played[i] = 0;//reset each square
				i++;
			}
			Winner(0);//reset winner, also reset game over bool
			break;
		}
	}
}

//ai
function ComputerGo()
{
	local int i;
	local bool bGood;//is there a spot to move
	i = 0;
	while ( i < 9 )
	{
		if ( Played[i] == 0 )
		bGood = true;
		i++;
	}
	if ( !bGood )//draw
		return;
	Calculate();
	if ( IsWinner() == 2 )
		Winner(2);
}

//calculates best comp move
function Calculate()
{
	local int i;
	local array<int> sq;
	//find a winner:
	i = FindAWinner(2);
	if ( i != 9 )
	{
		ComputerMove(i);
		return;
	}
	//stop a winner:
	i = FindAWinner(1);
	if ( i != 9 )
	{
		ComputerMove(i);
		return;
	}
	//corner squares if possible
	if ( Played[0] == 0 )
	sq[sq.length] = 1;
	if ( Played[2] == 0 )
	sq[sq.length] = 3;
	if ( Played[6] == 0 )
	sq[sq.length] = 7;
	if ( Played[8] == 0 )
	sq[sq.length] = 9;
	if( sq.length > 0 )
	{
		ComputerMove(sq[rand(sq.length)] - 1);
		return;
	}
	i = rand(9);
	while ( Played[i] != 0 )
	{
		i = rand(9);
	}
	ComputerMove(i);
}

//calculates a winning move
function int FindAWinner(int t)
{
	local int i,j,k,l;//i is sq index, j is column/row we are in, k is adjacent squares to check, l is how many nearby are already taken by player
	local array<int> sq;
	i = 1;
	while ( i < 10 )//get free squares
	{
		if ( Played[i-1] == 0 )//free
		{
			sq[sq.length] = i;
		}
		i++;
	}
	//note: sq value is 1 greater than it should be (because array treats 0 as null value?)
	i = 0;
	while ( i < sq.length )//check each free square
	{
		//CHECK HORIZONTAL
		l = 0;//l is how many nearby squares are taken
		j = sq[i] - 1;
		while ( j > 2 )//finds the column we are in
		{
			j = j - 3;
		}
		k = sq[i] - 2;//to left
		while ( k > ( sq[i] - ( j + 1 ) - 1 ) )
		{
			if ( Played[k] == t )
			{
				l++;
			}
			k--;
		}
		k = sq[i];//to right
		while ( k < ( sq[i] + ( 2 - j ) ) )
		{
			if ( Played[k] == t )
			{
				l++;
			}
			k++;
		}
		if ( l > 1 )
		{
			return sq[i] - 1;
		}
		//CHECK VERTICAL
		l = 0;//l is how many nearby squares are taken
		//no need to check rows for this because a simple bounds test tells you when you've gone too far
		k = sq[i] - 4;//check up
		while ( k > -1 )
		{
			if ( Played[k] == t )
			{
				l++;
			}
			k = k - 3;
		}
		k = sq[i] + 2;//check down
		while ( k < 9 )
		{
			if ( Played[k] == t )
			{
				l++;
			}
			k = k + 3;
		}
		if ( l > 1 )
		{
			return sq[i] - 1;
		}
		//CHECK DIAGONAL 4s
		l = 0;
		if ( ( sq[i] - 1 == 0 ) || ( sq[i] - 1 == 4 ) || ( sq[i] - 1 == 8 ) )//multiple of 4
		{
			k = sq[i] - 5;//check left up
			while ( k > -1 )
			{
				if ( Played[k] == t )
				{
					l++;
				}
				k = k - 4;
			}
			k = sq[i] + 3;//check right down
			while ( k < 9 )
			{
				if ( Played[k] == t )
				{
					l++;
				}
				k = k + 4;
			}
		}
		if ( l > 1 )
		{
			return sq[i] - 1;
		}
		//CHECK DIAGONAL 2s
		l = 0;
		if ( ( sq[i] - 1 == 2 ) || ( sq[i] - 1 == 4 ) || ( sq[i] - 1 == 6 ) )//multiple of 2
		{
			k = sq[i] - 3;//check right up
			while ( k > 1 )
			{
				if ( Played[k] == t )
				{
					l++;
				}
				k = k - 2;
			}
			k = sq[i] + 1;//check left down
			while ( k < 7 )
			{
				if ( Played[k] == t )
				{
					l++;
				}
				k = k + 2;
			}
		}
		if ( l > 1 )
		{
			return sq[i] - 1;
		}
		i++;
	}
	return 9;
}

//makes a move for the comp
function ComputerMove(int i)
{
	Spot[i].SetText("O");
	Played[i] = 2;
}

//returns 0 for no, 1 for human, 2 for comp
function int IsWinner()
{
	local int i;
	i = 0;//check vert
	while ( i < 3 )
	{
		if ( ( Played[i] == Played[i+3] ) && ( Played[i] == Played[i+6] ) && ( Played[i] != 0 ) )
			return Played[i];
		i++;
	}
	i = 0;//check horiz
	while ( i < 9 )
	{
		if ( ( Played[i] == Played[i+1] ) && ( Played[i] == Played[i+2] ) && ( Played[i] != 0 ) )
			return Played[i];
		i = i + 3;
	}
	//diag
	if ( ( Played[0] == Played[4] ) && ( Played[0] == Played[8] ) && ( Played[0] != 0 ) )
		return Played[0];
	if ( ( Played[2] == Played[4] ) && ( Played[2] == Played[6] ) && ( Played[2] != 0 ) )
		return Played[2];
	return 0;
}

function Winner(int i)
{
	switch ( i )
	{
		case 1:
		tWinner.Text = "You win!";
		bOver = true;
		break;
		case 2:
		tWinner.Text = "Comp wins!";
		bOver = true;
		break;
		default:
		tWinner.Text = " ";
		bOver = false;
		break;
	}
}

function Created ()
{
	super.Created();
	Spot[0] = R6WindowButton(CreateControl(class'R6WindowButton',WinLeft+3,WinTop,15,15,self));
	Spot[0].SetText(" ");
	Spot[1] = R6WindowButton(CreateControl(class'R6WindowButton',WinLeft+20,WinTop,15,15,self));
	Spot[1].SetText(" ");
	Spot[2] = R6WindowButton(CreateControl(class'R6WindowButton',WinLeft+37,WinTop,15,15,self));
	Spot[2].SetText(" ");
	Spot[3] = R6WindowButton(CreateControl(class'R6WindowButton',WinLeft+3,WinTop+17,15,15,self));
	Spot[3].SetText(" ");
	Spot[4] = R6WindowButton(CreateControl(class'R6WindowButton',WinLeft+20,WinTop+17,15,15,self));
	Spot[4].SetText(" ");
	Spot[5] = R6WindowButton(CreateControl(class'R6WindowButton',WinLeft+37,WinTop+17,15,15,self));
	Spot[5].SetText(" ");
	Spot[6] = R6WindowButton(CreateControl(class'R6WindowButton',WinLeft+3,WinTop+34,15,15,self));
	Spot[6].SetText(" ");
	Spot[7] = R6WindowButton(CreateControl(class'R6WindowButton',WinLeft+20,WinTop+34,15,15,self));
	Spot[7].SetText(" ");
	Spot[8] = R6WindowButton(CreateControl(class'R6WindowButton',WinLeft+37,WinTop+34,15,15,self));
	Spot[8].SetText(" ");
	bComp = R6WindowButton(CreateControl(class'R6WindowButton',WinLeft+71,WinTop,80,15,self));
	bComp.SetText("Computer go");
	tWinner = R6WindowTextLabel(CreateWindow(class'R6WindowTextLabel',WinLeft+71,WinTop+17,80,15,self));
	tWinner.m_bDrawBorders = false;
	tWinner.Align = TA_Left;
	tWinner.m_Font = Root.Fonts[F_SmallTitle];
	tWinner.m_BGTexture = none;
	tWinner.Text = " ";
	bReset = R6WindowButton(CreateControl(class'R6WindowButton',WinLeft+71,WinTop+34,80,15,self));
	bReset.SetText("Reset game");
}

function Paint(Canvas C,float X,float Y)
{
	super.Paint(C,X,Y);
	//draw a grid
	C.SetPos(WinLeft+16,WinTop);
	C.DrawVertical(WinLeft+16,49);
	C.SetPos(WinLeft+33,WinTop);
	C.DrawVertical(WinLeft+33,49);
	C.SetPos(WinLeft,WinTop+16);
	C.DrawHorizontal(WinTop+16,49);
	C.SetPos(WinLeft,WinTop+33);
	C.DrawHorizontal(WinTop+33,49);
}