class UTApp extends R6MenuFramePopup;//R6WindowFramedWindow;

//the basic app window for all Ultimate Tools apps
//the clientwindow is set by the UTController when needed

var bool bStarted;

//override
//all initialization to be handled below
function Created();

//start the class
function MakeAppWindow(string AppName,class<UWindowDialogClientWindow> AppClass)
{
	m_szWindowTitle = AppName;
	m_ClientClass = AppClass;
	super.Created();
	m_CloseBoxButton.Text = "X";
	m_CloseBoxButton.WinLeft = m_CloseBoxButton.WinLeft + 11;
	m_CloseBoxButton.WinTop = m_CloseBoxButton.WinTop + 4;
	bStarted = true;
}

//for consistent coloring
function Paint(Canvas C,float X,float Y)
{
	local Region R,Temp;
	local color iColor,iCDark;
	iColor.R = 0;
	iColor.G = 182;
	iColor.B = 182;
	iColor.A = 160;
	iCDark.R = 0;
	iCDark.G = 51;
	iCDark.B = 51;
	iCDark.A = 160;
	C.Style = 5;
	C.SetDrawColor(iColor.R,iColor.G,iColor.B,iColor.A);
	DrawStretchedTextureSegment(C,m_iTextureSize,m_iTextureSize,WinWidth-m_iTextureSize-m_iTextureSize,m_fTitleBarHeight- m_iTextureSize,0,0,m_iTextureSize,m_iTextureSize,m_Texture);
	C.Style = 5;
	C.SetDrawColor(iCDark.R,iCDark.G,iCDark.B,iColor.A);
	DrawStretchedTextureSegment(C,m_iTextureSize,m_fTitleBarHeight,WinWidth-m_iTextureSize-m_iTextureSize,WinHeight-m_fTitleBarHeight-m_iTextureSize,0,0,m_iTextureSize,m_iTextureSize,m_Texture);
	C.SetDrawColor(iColor.R,iColor.G,iColor.B);
	DrawStretchedTextureSegment(C,0,0,WinWidth,m_iTextureSize,0,0,m_iTextureSize,m_iTextureSize,m_Texture);
	DrawStretchedTextureSegment(C,0,m_fTitleBarHeight-1,WinWidth,m_iTextureSize,0,0,m_iTextureSize,m_iTextureSize,m_Texture);
	DrawStretchedTextureSegment(C,0,m_iTextureSize,m_iTextureSize,WinHeight-m_iTextureSize-m_iTextureSize,0,0,m_iTextureSize,m_iTextureSize,m_Texture);
	DrawStretchedTextureSegment(C,WinWidth-m_iTextureSize,m_iTextureSize,m_iTextureSize,WinHeight-m_iTextureSize-m_iTextureSize,0,0,m_iTextureSize,m_iTextureSize,m_Texture);
	DrawStretchedTextureSegment(C,0,WinHeight-m_iTextureSize,WinWidth,m_iTextureSize,0,0,m_iTextureSize,m_iTextureSize,m_Texture);
	C.Style = 5;
	C.Font = Root.Fonts[F_PopUpTitle];
	iColor = Root.Colors.White;
	C.SetDrawColor(iColor.R,iColor.G,iColor.B);
	ClipTextWidth(C,m_fTitleOffSet,3,m_szWindowTitle,WinWidth);
}

defaultproperties
{
	m_bSizable 	= false;
	m_bMovable 	= true;
	m_bDisplayClose = true;
	bAlwaysOnTop = true;
	bLeaveonScreen = true;
}