class UTNavBar extends R6MenuMPInGameNavBar;

var R6WindowButton bNext,bSkip;
var Texture tVote;
var Region rVoteU,rVoteD,rVoteDis,rVoteO;
var string map1,map2;

function MapNames(string s1,string s2)
{
	map1 = s1;
	map2 = s2;
	bNext.ToolTipString = "Vote for map " $ map1;
	bSkip.ToolTipString = "Vote for map " $ map2;
}

//make the buttons
function Created()
{
	bNext = R6WindowButton(CreateControl(class'R6WindowButton',430,23,rVoteU.W,rVoteU.H,self));//change first number to slide left or right on X axis
	bNext.UpTexture = tVote;
	bNext.OverTexture = tVote;
	bNext.DownTexture = tVote;
	bNext.DisabledTexture = tVote;
	bNext.UpRegion = rVoteU;
	bNext.DownRegion = rVoteD;   
	bNext.DisabledRegion = rVoteDis;
	bNext.OverRegion = rVoteO;	
	bNext.bUseRegion = true;
	bNext.ToolTipString = "Vote for map1";
	bNext.m_iDrawStyle  = 5; //Alpha
	bSkip = R6WindowButton(CreateControl(class'R6WindowButton',459,23,rVoteU.W,rVoteU.H,self));//change first number to slide left or right on X axis
	bSkip.UpTexture = tVote;
	bSkip.OverTexture = tVote;
	bSkip.DownTexture = tVote;
	bSkip.DisabledTexture = tVote;
	bSkip.UpRegion = rVoteU;
	bSkip.DownRegion = rVoteD;   
	bSkip.DisabledRegion = rVoteDis;
	bSkip.OverRegion = rVoteO;	
	bSkip.bUseRegion = true;
	bSkip.ToolTipString = "Vote for map2";
	bSkip.m_iDrawStyle = 5; //Alpha
	super.Created();
}

//give even spacing between buttons
function AlignButtons()
{
	local float fFreeSpace,fDistanceBetEachBut;
	fFreeSpace = WinWidth - 4; // 2 pixels each side for border lines
	fFreeSpace -= m_SelectTeamButton.WinWidth + m_ServerOptButton.WinWidth + m_KitRestrictionButton.WinWidth + m_GearButton.WinWidth + m_pPlayerReady.WinWidth + bSkip.WinWidth + bNext.WinWidth;
	if ( fFreeSpace > WinWidth )
	{
		fFreeSpace = WinWidth;
	}
	fDistanceBetEachBut = fFreeSpace / 8; //7 buttons + 1 space --> 1_2_3_4_5_6_7_8
	m_SelectTeamButton.WinLeft = fDistanceBetEachBut;
	m_ServerOptButton.WinLeft = m_SelectTeamButton.WinLeft + m_SelectTeamButton.WinWidth + fDistanceBetEachBut;
	m_KitRestrictionButton.WinLeft = m_ServerOptButton.WinLeft + m_ServerOptButton.WinWidth + fDistanceBetEachBut;
	m_GearButton.WinLeft = m_KitRestrictionButton.WinLeft + m_KitRestrictionButton.WinWidth + fDistanceBetEachBut;
	bNext.WinLeft = m_GearButton.WinLeft + m_GearButton.WinWidth + fDistanceBetEachBut;
	bSkip.WinLeft = bNext.WinLeft + bNext.WinWidth + fDistanceBetEachBut;
	m_pPlayerReady.WinLeft = bSkip.WinLeft + bSkip.WinWidth + fDistanceBetEachBut;
}

//click on button
function Notify(UWindowDialogControl C, byte E)
{	
	local R6MenuInGameMultiPlayerRootWindow R6Root;
	super.Notify(C,E);
	if ( E == DE_Click )
	{
		R6Root = R6MenuInGameMultiPlayerRootWindow(Root);
		switch(C)
		{
			case bNext:
			UTController(GetPlayerOwner()).VoteMap(map1);
			break;
			case bSkip:
			UTController(GetPlayerOwner()).VoteMap(map2);
			break;
		}
	}
}

//hide buttons during gameplay
function SetNavBarButtonsStatus(bool _bDisplay)
{
	if ( _bDisplay )
	{
		m_SelectTeamButton.ShowWindow();
		m_ServerOptButton.ShowWindow();
		m_KitRestrictionButton.ShowWindow();
		m_GearButton.ShowWindow();	
		m_pPlayerReady.ShowWindow();
		bNext.ShowWindow();
		bSkip.ShowWindow();
	}
	else
	{
		m_SelectTeamButton.HideWindow();
		m_ServerOptButton.HideWindow();
		m_KitRestrictionButton.HideWindow();
		m_GearButton.HideWindow();	
		m_pPlayerReady.HideWindow();
		bNext.HideWindow();
		bSkip.HideWindow();
	}
}

defaultproperties
{
	tVote=Texture'R6MenuTextures.Gui_01'
	rVoteU=(X=64,Y=0,W=29,H=30)
	rVoteD=(X=64,Y=60,W=29,H=30)
	rVoteDis=(X=64,Y=90,W=29,H=30)
	rVoteO=(X=64,Y=30,W=29,H=30)
	//change these to move the buttons over
	//do they even matter?
	m_iXNavBarLoc(0)=160
	m_iXNavBarLoc(1)=250
	m_iXNavBarLoc(2)=340
	m_iXNavBarLoc(3)=430
}