class UTPawn extends R6RainbowPawn;

//modified pawn class for the Ultimate Tools mod
//changes some death code so our custom death messages can get more info

var bool bExplosion;//died from explosion

//force kill sets the explosion flag on
function ServerForceKillResult(int iKillResult)
{
	bExplosion = true;
	super.ServerForceKillResult(iKillResult);
}

//sends increased info to controller classes, about weapon name and headshot
function R6Died(Pawn Killer,eBodyPart eHitPart,vector vMomentum)
{
	local UTController P;
	local string WeaponName;
	local string szPlayerName;
	local string KillerName;
	local R6Weapons R6W;
	local bool bHeadshot;
	super.R6Died(Killer,eHitPart,vMomentum);//call super - the old clientdeathmessage function has been removed
	//get killer's name
	if ( Killer.PlayerReplicationInfo != none )
	KillerName = Killer.PlayerReplicationInfo.PlayerName;
	else
	KillerName = Killer.m_CharacterName;
	//get killer's gun
	R6W = R6Weapons(Killer.EngineWeapon);
	if ( R6W != none )//possible problem - changed weapon before this gets called?
	WeaponName = Localize(R6W.m_NameID,"ID_SHORTNAME","R6Weapons");
	if ( bExplosion )
	WeaponName = "explosion";
	//get headshot
	if ( eHitPart == eBodyPart.BP_Head )
	bHeadshot = true;
	if ( ProcessBuildDeathMessage(Killer,szPlayerName) )
	{
		foreach DynamicActors(class'UTController',P)
		{
			P.xClientDeathMessage(KillerName,szPlayerName,m_bSuicideType,WeaponName,bHeadshot);
		}
	}
}