class UTPlatformApp extends UWindowDialogClientWindow;

//platformer game
//doesn't work too well, not implemented for now

#exec OBJ LOAD FILE="..\Textures\Color.utx" PACKAGE=Color

//height of title bar is 23 (+5)
//16x16 tiles, 20 on each axis

//GAME
var float fSpeed;//to get framerate, use 1/fSpeed

//MAP
struct tile
{
	var int iColor;//0 is blue, 1 is white, 2 is green
	var int iCollision;//0 is no, 1 is yes, 2 is special case
};
var tile tiles[400];//the 400 visible tiles

//CHARACTER
var vector cPos,cSpeed,cTargetSpeed;//char pos, current speed, target speed
var int cMaxSpeed;//maximum speed
var float accelf,jumpf;//acceleration factor - lower when not actively pressing a key, to prevent crazy sliding, jump factor
var float acceleration;
var bool bJump,bRise;//is jumping, going up

function Created()
{
	super.Created();
	SetAcceptsHotKeys(true);//can get hotkey function
	//vars
	acceleration = 2.3;
	cMaxSpeed = 150;
	cTargetSpeed.Y = cMaxSpeed;//gravity
	bJump = false;
	bRise = false;
	//create game
	CreateRandomGame();
}

//creates a randomized game
//starts always in bottom right corner
function CreateRandomGame()
{
	local int i;
	cPos.X = 0;
	cPos.Y = 288;//start on top of tile 380
	i = 0;
	while ( i < 400 )//set all tiles blue
	{
		SetTile(i,0,0);
		i++;
	}
	SetTile(380,1,1);//380 is always white since we start there
}

//draws our game
//does movement
function Paint(Canvas C,float fX,float fY)
{
	local int i,x,y;
	local vector cDir;//direction moving
	super.Paint(C,fX,fY);
	i = 0;
	while ( i < 400 )
	{
		GetTilePos(i,x,y);
		Draw(C,tiles[i].iColor,x,y);//draw each tile
		i++;
	}
	//player movement
	cDir.X = sign(cTargetSpeed.X - cSpeed.X);//find which direction to move
	cDir.Y = sign(cTargetSpeed.Y - cSpeed.Y);
	cSpeed += acceleration * cDir;//apply acceleration in proper direction
//	cSpeed.X = cSpeed.X * accelf;//acceleration factor comes into play only on x axis
//	cSpeed.Y = cSpeed.Y * jumpf;//jump factor comes into play only on y axis
	if ( sign(cTargetSpeed.X - cSpeed.X) != cDir.X )//adjust speed if at max speed already
	cSpeed.X = cTargetSpeed.X;
	if ( sign(cTargetSpeed.Y - cSpeed.Y) != cDir.Y )//adjust speed if at max speed already
	cSpeed.Y = cTargetSpeed.Y;
	if ( sign(cSpeed.Y) < 0 )//we are rising
	bRise = true;
	else
	bRise = false;
	cPos += cSpeed * fSpeed;//update position according to framerate
	cPos.X = clamp(cPos.X,0,296);//keep in bounds of game
	cPos.Y = clamp(cPos.Y,0,312);//keep in bounds of game but can fall further
	//collision below
	if ( ( tiles[GetTileNum(cPos.X,cPos.Y + 15)].iCollision == 1 ) || ( tiles[GetTileNum(cPos.X + 15,cPos.Y + 15)].iCollision == 1 ) )//if our bottom pixel encroaches on left or right side
	{
		bJump = false;//we are on a surface, can jump again
		x = cPos.X;
		y = cPos.Y + 15;
		i = GetTileNum(x,y);//get the number of the tile we collide with
		GetTilePos(i,x,y);//get x and y of tile we are colliding with
		cPos.Y = y - 16;//put us 16 pixels above collided tile
	}
	//player drawing in red
	Draw(C,3,cPos.X,cPos.Y);
	if ( cPos.Y >= 312 )//fell out of world
	Died();
}

//gets player input
function bool HotKeyDown(int Key,float X,float Y)
{
	switch ( Key )
	{
		case Root.Console.EInputKey.IK_Left:
		cTargetSpeed.X = cMaxSpeed * -1;
		break;
		case Root.Console.EInputKey.IK_Right:
		cTargetSpeed.X = cMaxSpeed;
		break;
		case Root.Console.EInputKey.IK_Up:
		if ( !bJump )
		{
			cTargetSpeed.Y = cMaxSpeed * -1;
			bJump = true;
		}
		else if ( bRise )//going up and still have hand on button
		{
			cTargetSpeed.Y = cMaxSpeed / 2;
		}
		break;
	}
	return false;
}

function bool HotKeyUp(int Key,float X,float Y)
{
	switch ( Key )
	{
		case Root.Console.EInputKey.IK_Left:
		cTargetSpeed.X = 0;
		break;
		case Root.Console.EInputKey.IK_Right:
		cTargetSpeed.X = 0;
		break;
		case Root.Console.EInputKey.IK_Up:
		cTargetSpeed.Y = cMaxSpeed;//fall full speed
		break;
	}
	return false;
}

//draws a tile in the correct color
//Y-coords sent here should be shifted down by 8!
function Draw(Canvas C,int i,int x,int y)
{
	switch ( i )
	{
		case 1://white land
		C.SetDrawColor(255,255,255);
		break;
		case 2://green stuff
		C.SetDrawColor(0,255,0);
		break;
		case 3://red character
		C.SetDrawColor(255,0,0);
		break;
		default://blue sky
		C.SetDrawColor(0,0,255,150);
		break;
	}
	C.Style = 5;//alpha
	DrawStretchedTexture(C,x,y+8,16,16,Texture'Color.White');//slide everything down by 8 to align
}

//gives the pixel location of top left of a tile
function GetTilePos(int num,out int i,out int j)
{
	i = num;
	while ( i > 19 )
	{
		i -= 20;//remove twenties until we find how many tiles across we are
	}
	j = (num-i) / 20;//make a multiple of twenty, then divide to find how many tiles down we are
	i = (i * 16);
	j = (j * 16);
}

//takes a pixel position and returns the collision setting for that particular tile
function int GetTileNum(int x,int y)
{
	local int i,j;
	i = 0;
	while ( x > 15 )//find out how many tiles across we are
	{
		x -= 16;
		i++;
	}
	j = 0;
	while ( y > 15 )//find how many tiles down we are
	{
		y -=16;
		j++;
	}
	return i + (j*20);
}

//sets a tile to desired color and collision
function SetTile(int num,int i,int c)
{
	tiles[num].iColor = i;
	tiles[num].iCollision = c;
}

//gets the direction of movement
//negative is left/up
function int sign(coerce float f)
{
	if ( f > 0 )
	return 1;
	else if ( f < 0 )
	return -1;
	else
	return 0;
}

function Died()
{
	GetPlayerOwner().ClientMessage("You died.");
	cSpeed = vect(0,0,0);//reset speed
	cTargetSpeed = vect(0,0,0);//reset acceleration
	bJump = false;//not jumping
	bRise = false;//not going up
	cPos.X = 0;
	cPos.Y = 288;//start on top of tile 380
}

//measures game speed
function Tick(float Delta)
{
	super.Tick(Delta);
	fSpeed = Delta;
}